/// <reference path="../lib/jquery.d.ts" />

export class MagicSearch {
    public element: any;
    public $element: any;
    public options: MagicSearchOptions;

    constructor(element, options) {
        this.element = element;
        this.$element = $(element);
        this.options = options;
        this.options = $.extend({}, MagicSearchDefaultOptions, options);
    }

    public static defaults = MagicSearchDefaultOptions;
}
export interface MagicSearchOptions {
    dataSource: any
    type?: string
    ajaxOptions?: any
    id: string
    hidden?: boolean
    fields: any
    format: string
    inputFormat?: string
    maxShow?: number
    isClear?: boolean
    showSelected?: boolean
    dropdownBtn?: boolean
    dropdownMaxItem?: number
    multiple?: boolean
    maxItem?: any
    showMultiSkin?: boolean
    multiStyle?: any
    multiField?: string
    focusShow?: boolean
    noResult?: string
    skin?: string
    disableRule?: Function
    success?: Function
    afterDelete?: Function
}

class MagicSearchDefaultOptions implements MagicSearchOptions {
    dataSource: any = [];
    type: string = '';
    ajaxOptions: any = '';
    id: string = '';
    hidden: boolean = false;
    fields: any = '';
    format: string = '';
    inputFormat: string = '';
    maxShow: number = 5;
    isClear: boolean = true;
    showSelected: boolean = true;
    dropdownBtn: boolean = false;
    dropdownMaxItem: number = 8;
    multiple: boolean = false;
    maxItem: any = true;
    showMultiSkin: boolean = true;
    multiStyle: any = '';
    multiField: string = '';
    focusShow: boolean = false;
    noResult: string = '';
    skin: string = '';
    disableRule: Function = data => false;
    success: Function = ($input, data) => true;
    afterDelete: Function = ($input, data) => true;
}
